﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Tort
{
    class Tort
    {
        public int Szaml { get; set; }
        public int Nev { get; set; }
        public int Lnko { get; set; }
        public int Sz { get; set; }
        public int N { get; set; }



        public Tort(int _szaml, int _nev, int _lnko)
        {
            Szaml = _szaml;
            Nev = _nev;
            Lnko = _lnko;
            Sz = Szaml / Lnko;
            N = Nev / Lnko;
        }

        public string KiTort(bool eredeti)
        {
            if (eredeti)
            {
                return Szaml.ToString() + "/" + Nev.ToString();
            }
            else
            {
                return Sz.ToString() + "/" + N.ToString();
            }

        }

        public string KiTortE(bool eredeti)
        {
            if (eredeti)
            {
                return Szaml.ToString() + ((Nev != 1) ? ("/" + Nev.ToString()) : "");
            }
            else
            {
                return Sz.ToString() + ((N != 1) ? ("/" + N.ToString()) : "");
            }

        }
    }

    class Program
    {
        static void Main(string[] args)
        {

            #region 1. feladat, egész szám-e
            Console.WriteLine("1. feladat");
            Console.Write("\tAdja meg a számlálót: ");
            int s = int.Parse(Console.ReadLine());
            Console.Write("\tAdja meg a nevezőt: ");
            int n = int.Parse(Console.ReadLine());
            Console.WriteLine(s % n == 0 ? (s / n).ToString() : "Nem egész szám");
            #endregion

            #region 2. feladat
            Tort tort1 = new Tort(s, n, Lnko(s, n));
            #endregion

            #region 3. feladat
            Console.WriteLine("3. feladat");
            Console.WriteLine("{0} = {1}", tort1.KiTort(true), tort1.KiTortE(false));
            #endregion

            #region 4. feladat, szorzat
            Console.WriteLine("4. feladat");
            Console.Write("\tAdja meg a számlálót: ");
            s = int.Parse(Console.ReadLine());
            Console.Write("\tAdja meg a nevezőt: ");
            n = int.Parse(Console.ReadLine());
            Tort tort2 = new Tort(s, n, Lnko(s, n));
            Tort szorzat = Szorzat(tort1, tort2);
            Console.WriteLine("{0} * {1} = {2} = {3}", tort1.KiTort(true), tort2.KiTort(true), szorzat.KiTort(true), szorzat.KiTortE(false));
            #endregion

            #region 5. feladat, összeg
            //a feladat szerint az eredeti értékekből kell kiindulni, de az egyszerüsített alakból lenne célszerű
            int lkkt = Lkkt(tort1, tort2);
            Tort btort1 = Btort(tort1, lkkt);
            Tort btort2 = Btort(tort2, lkkt);
            Tort osszeg = Osszeg(btort1, btort2);
            #endregion

            #region 6. feladat
            Console.WriteLine("6. feladat");
            Console.WriteLine("{0} + {1} = {2} + {3} = {4} = {5}", tort1.KiTort(true), tort2.KiTort(true), btort1.KiTort(true), btort2.KiTort(true), osszeg.KiTort(true), osszeg.KiTortE(false));
            #endregion

            #region 7. feladat beolvasás és eredmények kiírása

            using (System.IO.StreamWriter sw = new System.IO.StreamWriter("eredmeny.txt"))
            {
                using (System.IO.StreamReader sr = new System.IO.StreamReader("adat.txt"))
                {

                    while (!sr.EndOfStream)
                    {
                        string[] f = sr.ReadLine().Split(' ');
                        tort1 = new Tort(int.Parse(f[0]), int.Parse(f[1]), Lnko(int.Parse(f[0]), int.Parse(f[1])));
                        tort2 = new Tort(int.Parse(f[2]), int.Parse(f[3]), Lnko(int.Parse(f[2]), int.Parse(f[3])));
                        if (f[4] == "+")
                        {
                            lkkt = Lkkt(tort1, tort2);
                            btort1 = Btort(tort1, lkkt);
                            btort2 = Btort(tort2, lkkt);
                             osszeg = Osszeg(btort1, btort2);
                             sw.WriteLine("{0} + {1} = {2} + {3} = {4}", tort1.KiTort(true), tort2.KiTort(true), btort1.KiTort(true), btort2.KiTort(true), osszeg.KiTortE(false));
                        }
                        else
                        {
                            szorzat = Szorzat(tort1, tort2);
                            sw.WriteLine("{0} * {1} = {2} = {3}", tort1.KiTort(true), tort2.KiTort(true), szorzat.KiTort(true), szorzat.KiTortE(false));
                        }
                    }
                }
            }
            Console.WriteLine("7. feladat Beolvasás és kiírás kész.");
            #endregion

            Console.ReadLine();
        }

        private static int Lkkt(Tort t1, Tort t2)
        {
            return t1.Nev * t2.Nev / Lnko(t1.Nev, t2.Nev);
        }

        private static Tort Btort(Tort t, int b)
        {
            int s = t.Szaml * b / t.Nev;
            return new Tort(s, b, Lnko(s, b));
        }

        private static Tort Osszeg(Tort t1, Tort t2)
        {
            Tort o;
            if (t1.Nev != t2.Nev)
            {
                o = new Tort(0, 0, 0);
            }
            else
            {
                o = new Tort(t1.Szaml + t2.Szaml, t1.Nev, Lnko(t1.Szaml + t2.Szaml, t1.Nev));
            }
            return o;
        }

        private static int Lnko(int a, int b)
        {

            if (a == b)
            {
                return a;
            }
            else if (a > b)
            {
                return Lnko(a - b, b);
            }
            else
            {
                return Lnko(a, b - a);
            }

        }

        private static Tort Szorzat(Tort t1, Tort t2)
        {
            int s = t1.Szaml * t2.Szaml;
            int n = t1.Nev * t2.Nev;
            return new Tort(s, n, t1.Lnko * t2.Lnko);
        }


    }
}
